import axios, { AxiosResponse } from 'axios';
import { Command, Client, CmdContext } from '../class';

export default class PGP_Upload extends Command {
  constructor(client: Client) {
    super(client);
    this.name = 'upload';
    this.aliases = ['add', 'link', 'connect'];
    this.description = 'Uploads your PGP public key as a file to our database for authenticity and identity verification.';
    this.usage = `${this.client.config.prefix}pgp ${this.name}`;
    this.permissions = 0;
    this.guildOnly = true;
    this.enabled = true;
  }

  public async run(ctx: CmdContext) {
    if (!ctx.message.attachments.length) return this.error(ctx.message.channel, 'Please upload your PGP public key as an attachment.');
    if (!await this.client.db.mongo.Member.exists({ userID: ctx.message.author.id })) {
      await this.client.db.mongo.Member.create({ userID: ctx.message.author.id });
    }
    const [pgpAttachment] = ctx.message.attachments;
    const pgpReq: AxiosResponse<string> = await axios(pgpAttachment.url);
    const pgp = pgpReq.data;
    try {
      await axios.post('https://certapi.libraryofcode.org/pgp', pgp);
    } catch {
      return this.error(ctx.message.channel, 'Unable to parse your PGP public key.');
    }
    await this.client.db.mongo.Member.updateOne({ userID: ctx.message.author.id }, { pgp });
    this.success(ctx.message.channel, 'PGP public key successfully uploaded to your account.');
  }
}
